%define gtkmajor	1
%define qtmajor		4

%define rev	32531

%define name	webkit
%define oname	WebKit
%define qtn	%mklibname QtWebKit %qtmajor
%define qtdev	%mklibname QtWebKit -d
%define gtk	%mklibname WebKitGtk %gtkmajor
%define gtkdev	%mklibname WebKitGtk -d

Summary:	Embeddable web component 
Name:		%{name}
Version:	0
Release:	%mkrel 0.%{rev}.2
License:	BSD-like
Group:		System/Libraries
# Use the nightlies, don't grab SVN directly: the nightlies are
# MASSIVELY smaller and easier to manage - AdamW 2008/04
Source0:	http://nightly.webkit.org/files/trunk/src/%{oname}-r%{rev}.tar.bz2
# From https://bugs.webkit.org/show_bug.cgi?id=14750 :
# enables plugin support for webkitgtk - AdamW 2008/04
Patch0:		webkit-32489-plugin.patch
URL:		http://www.webkit.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	curl-devel >= 7.11.0
BuildRequires:	flex
BuildRequires:	fontconfig-devel >= 1.0.0
BuildRequires:	gperf
BuildRequires:	libicu-devel
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	librsvg-devel >= 2.2.0
BuildRequires:	libstdc++-devel
BuildRequires:	libtool 
BuildRequires:	libxslt-devel
BuildRequires:	pkgconfig
BuildRequires:	gtk2-devel
BuildRequires:	qt4-devel
BuildRequires:	qtxmllib
BuildRequires:	qtnetworklib
BuildRequires:	sqlite3-devel
BuildRequires:	xft2-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
WebKit is an open source web browser engine.

%package -n %qtn
Summary:	Web browser engine
Group:		System/Libraries
Obsoletes:	%{mklibname QtWebKit 0} <= 0-0.30465
Conflicts:	%{qtdev} <= 0-0.30465

%description -n %qtn
WebKit is an open source web browser engine.

%package -n %qtdev
Summary:	Development files for QtWebKit
Group:		Development/KDE and Qt
Provides:	QtWebKit-devel = %{version}-%{release}
Provides:	libQtWebKit-devel = %{version}-%{release}
Requires:	%{qtn} = %{version}-%{release}
Conflicts:	%{qtn} <= 0-0.30465

%description -n %qtdev
Development files for QtWebKit

%package -n %gtk
Summary:	Gtk port of WebKit
Group:		System/Libraries
Obsoletes:	%{mklibname WebKitGdk 0} <= 0-0.30465
Obsoletes:	%{mklibname WebKitGtk 0} <= 0-0.30465

%description -n %gtk
The Gtk port of WebKit is intended to provide a browser component primarily for
users of the portable Gtk+ UI toolkit on platforms like Linux.

%package -n %gtkdev
Summary:	Development files for WebKitGtk
Group:		Development/GNOME and GTK+
Provides:	WebKitGtk-devel = %{version}-%{release}
Provides:	libWebKitGtk-devel = %{version}-%{release}
Requires:	%{gtk} = %{version}-%{release}
Requires:	curl-devel >= 7.11.0
Requires:	fontconfig-devel >= 1.0.0
Requires:	librsvg-devel >= 2.2.0
Requires:	libstdc++-devel
Requires:	xft2-devel >= 2.0.0
Requires:	libnspr-devel

%description -n %gtkdev
Development files for GtkWebKit

%package gtklauncher
Summary:	GtkWebKit example application
Group:		Development/GNOME and GTK+
Conflicts:	%mklibname WebKitGtk 0 <= 0-0.30465

%description gtklauncher
GtkLauncher is an example application for WebKitGtk.

%package qtlauncher
Summary:	GtkWebKit example application
Group:		Development/KDE and Qt
Conflicts:	%mklibname QtWebKit 0 <= 0-0.30465

%description qtlauncher
QtLauncher is an example application for QtWebKit.

%prep
%setup -q -n %{oname}-r%{rev}
%patch0 -p0 -b .plugin

%build
mkdir -p build-gtk
pushd build-gtk
../autogen.sh
CONFIGURE_TOP=../ %configure2_5x --enable-svg-experimental
%make
popd

mkdir -p build-qt
cd build-qt

%{qt4bin}/qmake -r \
	OUTPUT_DIR="$PWD" \
	QMAKE_STRIP=/bin/true \
	QMAKE_RPATH= \
	QMAKE_CFLAGS="%{optflags}" \
	QMAKE_CXXFLAGS="%{optflags}" \
	VERSION=%qtmajor \
	CONFIG+=qt-port CONFIG-=plugins \
	WEBKIT_INC_DIR=%{_includedir}/WebKit \
	WEBKIT_LIB_DIR=%{_libdir} \
	../WebKit.pro

%make
 
%install
rm -rf %{buildroot}
pushd build-gtk
%makeinstall_std
popd
mkdir -p %{buildroot}%{_libdir}/WebKit
install -m 755 build-gtk/Programs/GtkLauncher %{buildroot}%{_libdir}/WebKit

make -C build-qt install INSTALL_ROOT=%{buildroot}
mkdir -p %{buildroot}%{qt4lib}/WebKit
install -m 755 build-qt/bin/QtLauncher %{buildroot}%{qt4lib}/WebKit
install -m 755 build-qt/bin/DumpRenderTree %{buildroot}%{qt4lib}/WebKit
#FIXME find how to tell qmake to put it there
mv %{buildroot}%{qt4lib}/pkgconfig/QtWebKit.pc %{buildroot}%{_libdir}/pkgconfig/QtWebKit.pc

%clean
rm -rf %{buildroot}

%post -n %qtn -p /sbin/ldconfig
%postun	-n %qtn -p /sbin/ldconfig

%post -n %gtk -p /sbin/ldconfig
%postun	-n %gtk -p /sbin/ldconfig

%files -n %qtdev
%defattr(644,root,root,755)
%{qt4lib}/libQtWebKit.so
%{qt4lib}/libQtWebKit.prl
%{qt4include}/*
%{qt4dir}/mkspecs/features
%{qt4plugins}/imageformats/libqtwebico.so
%{_libdir}/pkgconfig/QtWebKit.pc
%{qt4lib}/WebKit/DumpRenderTree

%files -n %qtn
%defattr(644,root,root,755)
%{qt4lib}/libQtWebKit.so.%{qtmajor}*

%files qtlauncher
%defattr(0755,root,root)
%{qt4lib}/WebKit/QtLauncher

%files -n %gtkdev
%defattr(644,root,root,755)
%{_libdir}/lib%{name}-1.0.so
%{_libdir}/lib%{name}-1.0.la
%{_includedir}/%{name}-1.0
%{_libdir}/pkgconfig/%{name}-1.0.pc

%files -n %gtk
%defattr(644,root,root,755)
%{_libdir}/lib%{name}-1.0.so.%{gtkmajor}*

%files gtklauncher
%defattr(0755,root,root)
%{_libdir}/WebKit/GtkLauncher



%changelog
* Fri Apr 25 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.32531.2mdv2009.0
+ Revision: 197473
- tweak configure params to try and get 100/100 acid3
- drop all nspr stuff, it was a bogus addition to the plugin patch anyway

* Fri Apr 25 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.32531.1mdv2009.0
+ Revision: 197442
- update plugin patch (improved version from upstream)
- update nightly

* Wed Apr 23 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.32416.4mdv2009.0
+ Revision: 196963
- add qt43.patch to fix a bug which caused build with Qt < 4.4 to fail
- updated version of plugin patch
- new snapshot

* Fri Apr 18 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.31893.4mdv2009.0
+ Revision: 195485
- try and fix up the requires_exceptions again...

* Thu Apr 17 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.31893.3mdv2009.0
+ Revision: 195320
- same fix for this patch was needed as for the other one...
- updated version of upstream patch (earlier was incomplete)
- fix a stray reference to a non-existent file in upstream patch
- new version of the plugin patch from upstream bug, hopefully this one will work!

* Thu Apr 17 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.31893.2mdv2009.0
+ Revision: 195033
- drop the patch until i know why it's not working. anyway, it makes acid3 test crash the browser, for some reason
- fix nspr devel requires (autorequires has problems here)
- final plugin patch fixup (but it still doesn't seem to work...will consult with upstream)
- more patch fixing..
- buildrequires libnspr-devel
- ...and one more fix
- more hacking on the patch
- fix changed function name in patch
- oops, bump release
- readd GTK+ plugin patch (31326-plugin.patch), from upstream bug report slightly rediffed

* Tue Apr 15 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.31893.1mdv2009.0
+ Revision: 194083
- new snapshot 31893

* Thu Mar 20 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.31157.1mdv2008.1
+ Revision: 189105
- protect majors in file lists
- move DumpRenderTree to the qt -devel package (aka obey libification policy)
- adjust to new upstream build method for GTK build (using autotools not qmake)
- split GtkLauncher and QtLauncher into separate packages (they're mostly useless demo code and were breaking libification policy)
- correct majors
- use upstream nightly tarball instead of creating one ourselves (apart from anything else it's, like, ten times smaller)
- new snapshot

* Fri Feb 22 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.30465.1mdv2008.1
+ Revision: 173823
- drop Implement-plugin-support-in-GTK-backend.patch (merged upstream)
- new snapshot 30465

  + Thierry Vignaud <tvignaud@mandriva.com>
    - rebuild

* Fri Feb 08 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0-0.30005.1mdv2008.1
+ Revision: 163896
- Patch0: add support for external plugins (flashplayer and so forth). At the current stage this supports only GTK version of WebKit. Patch should be merged into upstream svn quite soon. For more info please see http://bugs.webkit.org/show_bug.cgi?id=14750
- fix buildroot

* Wed Jan 30 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.29866.1mdv2008.1
+ Revision: 160152
- new snapshot 29866

* Sat Jan 05 2008 Adam Williamson <awilliamson@mandriva.com> 0-0.29184.1mdv2008.1
+ Revision: 145662
- 29013 doesn't build, go to current (29184)
- new snapshot 29013 (required by latest midori)

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Thu Dec 13 2007 Adam Williamson <awilliamson@mandriva.com> 0-0.28663.1mdv2008.1
+ Revision: 119551
- package a newly-introduced file
- new SVN snapshot 28663

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix summary

* Wed Nov 21 2007 Thierry Vignaud <tvignaud@mandriva.com> 0-0.26100.2mdv2008.1
+ Revision: 111025
- rebuild for new libicu

* Mon Oct 08 2007 Pascal Terjan <pterjan@mandriva.org> 0-0.26100.1mdv2008.0
+ Revision: 95684
- Obsoletes libWebKitGdk0
- Update to revision 26100
- s/Gdk/Gtk/g; s/gdk/gtk/
- DumpRenderTree changed location

* Sun Sep 02 2007 Pascal Terjan <pterjan@mandriva.org> 0-0.25144.3mdv2008.0
+ Revision: 78087
- Add some BuildRequires for the Qt version
- Oops fix the Provides

* Sat Sep 01 2007 Pascal Terjan <pterjan@mandriva.org> 0-0.25144.2mdv2008.0
+ Revision: 77413
- Add some provides on -devel packages

* Sat Sep 01 2007 Pascal Terjan <pterjan@mandriva.org> 0-0.25144.1mdv2008.0
+ Revision: 77392
- Fix group
- Put QtWebKit.pc in a place where pkgconfig will find it
- Import webkit



* Fri Aug 31 2007 Pascal Terajn <pterjan@mandriva.org> 0-0.25144.1mdv2008.0
- Initial Mandriva package (some inspiration from Debian)
